#include <iostream>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    int n, q, a[50000], l[50000], r[50000], k, kmax;
    bool t;
    cin >> n >> q;
    for(int i=0; i<n; i++)
        cin >> a[i];
    for(int i=0; i<q; i++)
        cin >> l[i] >> r[i];
    for(int i=0; i<q; i++)
    {
        kmax=0;
        k=0;
        t=true;
        for(int j=l[i]; j<r[i]-1; j++)
        {
            if(a[j]&a[j+1]>a[j]^a[j+1])
            {
                k++;
            }
            else
            {
                if(k>kmax) kmax=k;
                k=0;
                t=false;
            }
            if(t) kmax=k;
        }
        if(kmax==0) kmax=1;
        cout << kmax << endl;
    }


    return 0;
}